#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define	MAXBUFF		0x1000

int main(int argc, char **argv)
{
	FILE	*infp;
	FILE	*outfp;

	int		buff[MAXBUFF];

	int		width,height;
	int		wb;
	int		x,y;
	int		m,n,i,j,k;
	int		col,colct;
	int		a0,a1,a2,a3,c;
	int		sft;
	int		filelen;

	if (argc != 3) {
		fprintf(stderr, "Usage: convchara infile outfile\n");
		exit(1);
	}

/* open files */

	if ((infp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((outfp = fopen(argv[2], "wb")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

	i = 0;
	while ( (c = fgetc(infp)) != EOF) {
		buff[i] = c;
		i ++;
	}
	filelen = i;

	for (i = 0;i < 0xf0;i ++) {

/* hbgԈ */
		for (y = 0;y < 8;y ++) {
			buff[i*16+y] =
						( ( (buff[i*16+y*2+0] & 0x80) != 0x00) ? 0x80 : 0x00) + 
						( ( (buff[i*16+y*2+0] & 0x20) != 0x00) ? 0x40 : 0x00) + 
						( ( (buff[i*16+y*2+0] & 0x08) != 0x00) ? 0x20 : 0x00) + 
						( ( (buff[i*16+y*2+0] & 0x02) != 0x00) ? 0x10 : 0x00) + 
						( ( (buff[i*16+y*2+1] & 0x80) != 0x00) ? 0x08 : 0x00) + 
						( ( (buff[i*16+y*2+1] & 0x20) != 0x00) ? 0x04 : 0x00) + 
						( ( (buff[i*16+y*2+1] & 0x08) != 0x00) ? 0x02 : 0x00) + 
						( ( (buff[i*16+y*2+1] & 0x02) != 0x00) ? 0x01 : 0x00);
		}

		for (y = 0;y < 8;y ++) {
			buff[i*16+y+8] = 0x00;
		}

/* ʏC */


		if (i == 0x09) {	/* ) */
			buff[i*16+0]=0x20;
			buff[i*16+1]=0x10;
			buff[i*16+2]=0x10;
			buff[i*16+3]=0x10;
			buff[i*16+4]=0x10;
			buff[i*16+5]=0x10;
			buff[i*16+6]=0x20;
			buff[i*16+7]=0x00;
		}

		if (i == 0x10) {	/* 0 */
			buff[i*16+0]=0x38;
			buff[i*16+1]=0x44;
			buff[i*16+2]=0x82;
			buff[i*16+3]=0x82;
			buff[i*16+4]=0x82;
			buff[i*16+5]=0x44;
			buff[i*16+6]=0x38;
			buff[i*16+7]=0x00;
		}

		if (i == 0x1b) {	/* ; */
			buff[i*16+0]=0x00;
			buff[i*16+1]=0x00;
			buff[i*16+2]=0x10;
			buff[i*16+3]=0x00;
			buff[i*16+4]=0x10;
			buff[i*16+5]=0x20;
			buff[i*16+6]=0x00;
			buff[i*16+7]=0x00;
		}

		if (i == 0x2f) {	/* O */
			buff[i*16+0]=0x38;
			buff[i*16+1]=0x44;
			buff[i*16+2]=0x82;
			buff[i*16+3]=0x82;
			buff[i*16+4]=0x82;
			buff[i*16+5]=0x44;
			buff[i*16+6]=0x38;
			buff[i*16+7]=0x00;
		}

		if (i == 0x3e) {	/*  */
			buff[i*16+0]=0x10;
			buff[i*16+1]=0x38;
			buff[i*16+2]=0x7c;
			buff[i*16+3]=0x10;
			buff[i*16+4]=0x10;
			buff[i*16+5]=0x10;
			buff[i*16+6]=0x10;
			buff[i*16+7]=0x00;
		}

		if (i == 0x41) {	/* B*/
			buff[i*16+0]=0x00;
			buff[i*16+1]=0x00;
			buff[i*16+2]=0x00;
			buff[i*16+3]=0x00;
			buff[i*16+4]=0x10;
			buff[i*16+5]=0x28;
			buff[i*16+6]=0x10;
			buff[i*16+7]=0x00;
		}

		if (i == 0x44) {	/* A*/
			buff[i*16+0]=0x00;
			buff[i*16+1]=0x00;
			buff[i*16+2]=0x00;
			buff[i*16+3]=0x00;
			buff[i*16+4]=0x20;
			buff[i*16+5]=0x10;
			buff[i*16+6]=0x08;
			buff[i*16+7]=0x00;
		}

		if (i == 0x7f) {	/* K*/
			buff[i*16+0]=0x40;
			buff[i*16+1]=0xa0;
			buff[i*16+2]=0x40;
			buff[i*16+3]=0x00;
			buff[i*16+4]=0x00;
			buff[i*16+5]=0x00;
			buff[i*16+6]=0x00;
			buff[i*16+7]=0x00;
		}

		if (i == 0x81) {	/* B*/
			buff[i*16+0]=0x00;
			buff[i*16+1]=0x00;
			buff[i*16+2]=0x00;
			buff[i*16+3]=0x00;
			buff[i*16+4]=0x10;
			buff[i*16+5]=0x28;
			buff[i*16+6]=0x10;
			buff[i*16+7]=0x00;
		}

		if (i == 0x84) {	/* A*/
			buff[i*16+0]=0x00;
			buff[i*16+1]=0x00;
			buff[i*16+2]=0x00;
			buff[i*16+3]=0x00;
			buff[i*16+4]=0x20;
			buff[i*16+5]=0x10;
			buff[i*16+6]=0x08;
			buff[i*16+7]=0x00;
		}

		if (i == 0xbf) {	/* K*/
			buff[i*16+0]=0x40;
			buff[i*16+1]=0xa0;
			buff[i*16+2]=0x40;
			buff[i*16+3]=0x00;
			buff[i*16+4]=0x00;
			buff[i*16+5]=0x00;
			buff[i*16+6]=0x00;
			buff[i*16+7]=0x00;
		}

		if (i == 0xc0) {	/*  */
			buff[i*16+0]=0x00;
			buff[i*16+1]=0x00;
			buff[i*16+2]=0x18;
			buff[i*16+3]=0x24;
			buff[i*16+4]=0x24;
			buff[i*16+5]=0x18;
			buff[i*16+6]=0x00;
			buff[i*16+7]=0x00;
		}

		if (i == 0xc1) {	/*  */
			buff[i*16+0]=0x00;
			buff[i*16+1]=0x18;
			buff[i*16+2]=0x24;
			buff[i*16+3]=0x42;
			buff[i*16+4]=0x42;
			buff[i*16+5]=0x24;
			buff[i*16+6]=0x18;
			buff[i*16+7]=0x00;
		}

		if (i == 0xcf) {	/*  */
			buff[i*16+0]=0x3c;
			buff[i*16+1]=0x7e;
			buff[i*16+2]=0xff;
			buff[i*16+3]=0xff;
			buff[i*16+4]=0xff;
			buff[i*16+5]=0xff;
			buff[i*16+6]=0x7e;
			buff[i*16+7]=0x3c;
		}

	}

	for (i = 0;i < filelen;i ++) {
		fputc(buff[i],outfp);
	}

	fclose(infp);
	fclose(outfp);

	return(0);
}

